Index: issm/trunk/src/m/interp/averaging.py
===================================================================
--- issm/trunk/src/m/interp/averaging.py	(revision 25994)
+++ issm/trunk/src/m/interp/averaging.py	(revision 26744)
@@ -29,8 +29,8 @@
     """
 
-    if len(data) != md.mesh.numberofelements and len(data) != md.mesh.numberofvertices:
+    if (len(data) != md.mesh.numberofelements) & (len(data) != md.mesh.numberofvertices):
         raise Exception('averaging error message: data not supported yet')
-    if md.mesh.dimension() == 3 and layer != 0:
-        if layer <= 0 or layer > md.mesh.numberoflayers:
+    if (md.mesh.dimension() == 3) & (layer != 0):
+        if (layer <= 0) | (layer > md.mesh.numberoflayers):
             raise ValueError('layer should be between 1 and md.mesh.numberoflayers')
     else:
@@ -39,9 +39,9 @@
     # Initialization
     if layer == 0:
-        weights = np.zeros(md.mesh.numberofvertices, )
-        data = data.flatten(1)
+        weights = np.zeros((md.mesh.numberofvertices, ))
+        data = np.asarray(data).flatten()
     else:
-        weights = np.zeros(md.mesh.numberofvertices2d, )
-        data = data[(layer - 1) * md.mesh.numberofvertices2d + 1:layer * md.mesh.numberofvertices2d, :]
+        weights = np.zeros((md.mesh.numberofvertices2d, ))
+        data = data[(layer - 1) * md.mesh.numberofvertices2d + 1:layer * md.mesh.numberofvertices2d - 1, :]
 
     # Load some variables (it is much faster if the variables are loaded from md once for all)
@@ -56,5 +56,5 @@
 
     # Build some variables
-    if md.mesh.dimension() == 3 and layer == 0:
+    if (md.mesh.dimension() == 3) & (layer == 0):
         rep = 6
         areas = GetAreas(index, md.mesh.x, md.mesh.y, md.mesh.z)
@@ -67,16 +67,16 @@
 
     index = index - 1  # Python indexes from zero
-    line = index.flatten(1)
+    line=index.T.flatten()
     areas = np.vstack(areas).reshape(-1, )
-    summation = 1. / rep * np.ones(rep, )
+    summation = 1. / rep * np.ones((rep,1) )
     linesize = rep * numberofelements
 
-    # Update weights that holds the volume of all the element holding the node i
-    weights = csc_matrix((np.tile(areas, (rep, 1)).reshape(-1, ), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
+    # Update weights that hold the volume of all the element holding the node i
+    weights = csc_matrix((np.tile(areas, (1, rep)).reshape(-1,), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
 
     # Initialization
     if len(data) == numberofelements:
-        average_node = csc_matrix((np.tile(areas * data, (rep, 1)).reshape(-1, ), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
-        average_node = average_node / weights
+        average_node = csc_matrix((np.tile(np.multiply(areas,data), (1, rep)).reshape(-1, ), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
+        average_node = np.divide(average_node,weights)
         average_node = csc_matrix(average_node)
     else:
@@ -85,11 +85,11 @@
     # Loop over iteration
     for i in np.arange(1, iterations + 1):
-        average_el = np.asarray(np.dot(average_node.todense()[index].reshape(numberofelements, rep), np.vstack(summation))).reshape(-1, )
-        average_node = csc_matrix((np.tile(areas * average_el.reshape(-1), (rep, 1)).reshape(-1, ), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
-        average_node = average_node / weights
+        average_el = np.asarray(average_node.todense()[index].reshape(numberofelements, rep)*summation).reshape(-1, )
+        average_node = csc_matrix((np.tile(np.multiply(areas,average_el.reshape(-1)), (1, rep)).reshape(-1, ), (line, np.zeros(linesize, ))), shape=(numberofnodes, 1))
+        average_node = np.divide(average_node,weights)
         average_node = csc_matrix(average_node)
 
     # Return output as a full matrix (C code does not like sparse matrices)
-    average = np.asarray(average_node.todense()).reshape(-1, )
+    average = np.expand_dims(np.asarray(average_node.todense()).reshape(-1, ),axis=1)
 
     return average
Index: issm/trunk/src/m/io/loadvars.py
===================================================================
--- issm/trunk/src/m/io/loadvars.py	(revision 25994)
+++ issm/trunk/src/m/io/loadvars.py	(revision 26744)
@@ -52,5 +52,5 @@
         raise TypeError("Unrecognized input arguments.")
 
-    onlylast = True
+    onlylast = False
 
     for key, value in kwargs.items():
@@ -88,17 +88,17 @@
             #==== First we create the model structure  {{{
             if debug:
-                print(' - Now treating classtype {}'.format(mod))
-            if np.size(classtree[mod]) > 1:
+                print(' ==== Now treating classtype {}'.format(mod))
+            if mod not in classtree.keys():
+                print("WARNING: {} classe is not in the model anymore and will be omited.".format(mod))
+            elif np.size(classtree[mod]) > 1:
                 # this points to a subclass (results.TransientSolution for example)
                 curclass = NCFile.groups[classtree[mod][0]].groups[classtree[mod][1]]
                 if debug:
-                    print("===> {} is of class {}".format(mod, classtype[mod]))
+                    print("    ==> {} is of class {}".format(mod, classtype[mod]))
                 if classtype[mod][0] == 'results.solutionstep':  #Treating results {{{
                     keylist = [key for key in curclass.groups]
-                    # this is related to the old structure of NC files where every steps of results had its own group
                     #that is the current treatment
                     #here we have a more NC approach with time being a dimension
                     listtype = split(r'\.', classtype[mod][0])[0]
-                    print("listtype is {}".format(listtype))
                     if len(NCFile.dimensions['Time']) == 1:
                         nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = getattr(classtype[mod][1], listtype)()
@@ -110,12 +110,31 @@
                             Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]]
                         else:
-                            #nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = [getattr(classtype[mod][1], listtype)() for i in range(max(1, len(NCFile.dimensions['Time'])))]
-                            #Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]][:]
                             setattr(nvdict['md'].__dict__[classtree[mod][0]], classtree[mod][1], getattr(classtype[mod][1], 'solution')([]))
                             for i in range(max(1, len(NCFile.dimensions['Time']))):
                                 nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]].steps.append(getattr(classtype[mod][1], 'solutionstep')())
                             Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]][:]
-                            print(nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]].steps[0])
                 # }}}
+                elif "results" in mod and classtype[mod][0] == 'list':  #this is the old style of results where every step has a group{{{
+                    keylist = [key for key in curclass.groups]
+                    #one group per step so use that in place of time
+                    stepnum = len(NCFile.groups[classtree[mod][0]].groups[classtree[mod][1]].groups)
+                    #we need to redefine classtype from list to result
+                    listtype = 'results'
+                    classtype[mod].append(__import__(listtype))
+                    if stepnum == 1:
+                        nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = getattr(classtype[mod][1], listtype)()
+                        Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]]
+                    else:
+                        if onlylast:   #we load only the last result to save on time and memory
+                            nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = [getattr(classtype[mod][1], listtype)()]
+                            Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]]
+                        else:
+                            #nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = [getattr(classtype[mod][1], listtype)() for i in range(max(1, len(NCFile.dimensions['Time'])))]
+                            #Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]][:]
+                            setattr(nvdict['md'].__dict__[classtree[mod][0]], classtree[mod][1], getattr(classtype[mod][1], 'solution')([]))
+                            for i in range(max(1, stepnum)):
+                                nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]].steps.append(getattr(classtype[mod][1], 'solutionstep')())
+                            Tree = nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]][:]
+                    #}}}
                 elif classtype[mod][0] == 'massfluxatgate':  #this is for output definitions {{{
                     defname = split('Output|[0-9]+', classtree[mod][1])[1] + 's'
@@ -126,9 +145,9 @@
                 else:
                     if debug:
-                        print("Using the default for md.{}.{}, is that right??".format(classtree[mod][0], classtree[mod][1]))
+                        print("    Using the default for md.{}.{}, is that right??".format(classtree[mod][0], classtree[mod][1]))
                     try:
                         modulename = split(r'\.', classtype[mod][0])[0]
                         if debug:
-                            print("trying to import {} from {}".format(classtype[mod][0], modulename))
+                            print("    trying to import {} from {}".format(classtype[mod][0], modulename))
                         nvdict['md'].__dict__[classtree[mod][0]].__dict__[classtree[mod][1]] = getattr(classtype[mod][1], modulename)()
                     except AttributeError:
@@ -141,68 +160,75 @@
                 Tree = nvdict['md'].__dict__[classtree[mod][0]]
             if debug:
-                print("for {} Tree is a {}".format(mod, Tree.__class__.__name__))
+                print("    for {} Tree is a {} with len {}".format(mod, Tree.__class__.__name__, len(curclass.groups)))
             # }}}
             #==== Then we populate it {{{
-            for i in range(0, max(1, len(curclass.groups))):
-                if len(curclass.groups) > 0:
-                    listclass = curclass.groups[keylist[i]]
+            #for i in range(0, max(1, len(curclass.groups))):
+            if len(curclass.groups) > 0:  #that is presumably only for old style NC where each result step had its own group
+                if onlylast:
+                    groupclass = [curclass.groups[keylist[len(curclass.groups) - 1]]]
                 else:
-                    listclass = curclass
-                #==== We deal with Variables {{{
+                    groupclass = [curclass.groups[key] for key in keylist]
+            else:
+                groupclass = [curclass]
+            #==== We deal with Variables {{{
+            for groupindex, listclass in enumerate(groupclass):
                 for var in listclass.variables:
-                    if debug:
-                        print("treating var {}".format(var))
                     if var not in ['errlog', 'outlog']:
                         varval = listclass.variables[str(var)]
                         vardim = varval.ndim
+                        if debug:
+                            print("    ==> treating var {} of dimension {}".format(var, vardim))
                         #There is a special treatment for results to account for its specific structure
                         #that is the new export version where time is a named dimension
                         NewFormat = 'Time' in NCFile.dimensions
-                        if type(Tree) == list and NewFormat:
+                        if type(Tree) == list:  # and NewFormat:
                             if onlylast:
-                                if vardim == 1:
-                                    Tree[0].__dict__[str(var)] = varval[-1].data
-                                elif vardim == 2:
-                                    Tree[0].__dict__[str(var)] = varval[-1, :].data
-                                elif vardim == 3:
-                                    Tree[0].__dict__[str(var)] = varval[-1, :, :].data
+                                if NewFormat:
+                                    if vardim == 1:
+                                        Tree[0].__dict__[str(var)] = varval[-1].data
+                                    elif vardim == 2:
+                                        Tree[0].__dict__[str(var)] = varval[-1, :].data
+                                    elif vardim == 3:
+                                        Tree[0].__dict__[str(var)] = varval[-1, :, :].data
+                                    else:
+                                        print('table dimension greater than 3 not implemented yet')
+                                else:  #old format had step sorted in difeerent group so last group is last time
+                                    Tree[0].__dict__[str(var)] = varval[:].data
+                            else:
+                                if NewFormat:
+                                    incomplete = 'Time' not in varval.dimensions and NewFormat
+                                    if incomplete:
+                                        chosendim = varval.dimensions[0]
+                                        timelist = np.arange(0, len(NCFile.dimensions[chosendim]))
+                                        print('WARNING, {} is not present on every times, we chose {}({}) as the dimension to write it with'.format(var, chosendim, len(NCFile.dimensions[chosendim])))
+                                    else:
+                                        timelist = np.arange(0, len(NCFile.dimensions['Time']))
+                                    for t in timelist:
+                                        if debug:
+                                            print("filing step {} for {}".format(t, var))
+                                        if vardim == 0:
+                                            Tree[t].__dict__[str(var)] = varval[:].data
+                                        elif vardim == 1:
+                                            Tree[t].__dict__[str(var)] = varval[t].data
+                                        elif vardim == 2:
+                                            Tree[t].__dict__[str(var)] = varval[t, :].data
+                                        elif vardim == 3:
+                                            Tree[t].__dict__[str(var)] = varval[t, :, :].data
+                                        else:
+                                            print('table dimension greater than 3 not implemented yet')
                                 else:
-                                    print('table dimension greater than 3 not implemented yet')
-                            else:
-                                incomplete = 'Time' not in varval.dimensions
-                                if incomplete:
-                                    chosendim = varval.dimensions[0]
-                                    timelist = np.arange(0, len(NCFile.dimensions[chosendim]))
-                                    print('WARNING, {} is not present on every times, we chose {}({}) as the dimension to write it with'.format(var, chosendim, len(NCFile.dimensions[chosendim])))
-                                else:
-                                    timelist = np.arange(0, len(NCFile.dimensions['Time']))
-                                for t in timelist:
-                                    if vardim == 0:
-                                        Tree[t].__dict__[str(var)] = varval[:].data
-                                    if vardim == 1:
-                                        Tree[t].__dict__[str(var)] = varval[t].data
-                                    elif vardim == 2:
-                                        Tree[t].__dict__[str(var)] = varval[t, :].data
-                                    elif vardim == 3:
-                                        Tree[t].__dict__[str(var)] = varval[t, :, :].data
-                                    else:
-                                        print('table dimension greater than 3 not implemented yet')
+                                    if debug:
+                                        print("filing step {} for {}".format(groupindex, var))
+                                    Tree[groupindex].__dict__[str(var)] = varval[:].data
                         else:
                             if vardim == 0:  #that is a scalar
-                                if type(Tree) == list:
-                                    t = indexlist[i]
-                                    if listtype == 'dict':
-                                        Tree[t][str(var)] = varval[0].data
-                                    else:
-                                        Tree[t].__dict__[str(var)] = varval[0].data
+                                if str(varval[0]) == '':  #no value
+                                    Tree.__dict__[str(var)] = []
+                                elif varval[0] == 'True':  #treatin bool
+                                    Tree.__dict__[str(var)] = True
+                                elif varval[0] == 'False':  #treatin bool
+                                    Tree.__dict__[str(var)] = False
                                 else:
-                                    if str(varval[0]) == '':  #no value
-                                        Tree.__dict__[str(var)] = []
-                                    elif varval[0] == 'True':  #treatin bool
-                                        Tree.__dict__[str(var)] = True
-                                    elif varval[0] == 'False':  #treatin bool
-                                        Tree.__dict__[str(var)] = False
-                                    else:
-                                        Tree.__dict__[str(var)] = varval[0].item()
+                                    Tree.__dict__[str(var)] = varval[0].item()
 
                             elif vardim == 1:  #that is a vector
@@ -215,24 +241,17 @@
                                         Tree.__dict__[str(var)] = [str(vallue) for vallue in varval[:]]
                                 else:
-                                    if type(Tree) == list:
-                                        t = indexlist[i]
-                                        if listtype == 'dict':
-                                            Tree[t][str(var)] = varval[:].data
-                                        else:
-                                            Tree[t].__dict__[str(var)] = varval[:].data
-                                    else:
-                                        try:
-                                            #some thing specifically require a list
-                                            mdtype = type(Tree.__dict__[str(var)])
-                                        except KeyError:
-                                            mdtype = float
-                                        if mdtype == list:
-                                            Tree.__dict__[str(var)] = [mdval for mdval in varval[:]]
-                                        else:
-                                            Tree.__dict__[str(var)] = varval[:].data
+                                    try:
+                                        #some thing specifically require a list
+                                        mdtype = type(Tree.__dict__[str(var)])
+                                    except KeyError:
+                                        mdtype = float
+                                    if mdtype == list:
+                                        Tree.__dict__[str(var)] = [mdval for mdval in varval[:]]
+                                    else:
+                                        Tree.__dict__[str(var)] = varval[:].data
 
                             elif vardim == 2:
                                 #dealling with dict
-                                if varval.dtype == str:  #that is for toolkits wich needs to be ordered
+                                if varval.dtype == str:  #that is for dictionaries
                                     if any(varval[:, 0] == 'toolkit'):  #toolkit definition have to be first
                                         Tree.__dict__[str(var)] = OrderedDict([('toolkit', str(varval[np.where(varval[:, 0] == 'toolkit')[0][0], 1]))])
@@ -240,4 +259,8 @@
                                         strings2 = [str(arg[1]) for arg in varval if arg[0] != 'toolkits']
                                         Tree.__dict__[str(var)].update(list(zip(strings1, strings2)))
+                                    else:
+                                        strings1 = [str(arg[0]) for arg in varval]
+                                        strings2 = [str(arg[1]) for arg in varval]
+                                        Tree.__dict__[str(var)] = OrderedDict(list(zip(strings1, strings2)))
                                 else:
                                     if type(Tree) == list:
@@ -250,38 +273,23 @@
                                         Tree.__dict__[str(var)] = varval[:, :].data
                             elif vardim == 3:
-                                if type(Tree) == list:
-                                    t = int(indexlist[i])
-                                    if listtype == 'dict':
-                                        Tree[t][str(var)] = varval[:, :, :].data
-                                    else:
-                                        Tree[t].__dict__[str(var)] = varval[:, :, :]
-                                else:
-                                    Tree.__dict__[str(var)] = varval[:, :, :].data
+                                Tree.__dict__[str(var)] = varval[:, :, :].data
                             else:
                                 print('table dimension greater than 3 not implemented yet')
-                    # }}}
+                # }}}
                 #==== And with atribute {{{
                 for attr in listclass.ncattrs():
                     if debug:
-                        print("treating attribute {}".format(attr))
+                        print("      ==> treating attribute {}".format(attr))
                     if attr != 'classtype':  #classtype is for treatment, don't get it back
                         attribute = str(attr).swapcase()  #there is a reason for swapcase, no sure what it isanymore
                         if attr == 'VARNAME':
                             attribute = 'name'
-                        if type(Tree) == list and NewFormat:
+                        if type(Tree) == list:
                             if debug:
-                                print("printing with index 0")
+                                print("        printing with index 0")
                             if listtype == 'dict':
                                 Tree[0][attribute] = str(listclass.getncattr(attr))
                             else:
                                 Tree[0].__dict__[attribute] = str(listclass.getncattr(attr))
-                        elif type(Tree) == list:
-                            t = int(indexlist[i])
-                            if debug:
-                                print("printing with index {]".format(t))
-                            if listtype == 'dict':
-                                Tree[t][attribute] = str(listclass.getncattr(attr))
-                            else:
-                                Tree[t].__dict__[attribute] = str(listclass.getncattr(attr))
                         else:
                             Tree.__dict__[attribute] = str(listclass.getncattr(attr))
@@ -320,5 +328,4 @@
                     try:
                         modulename = split(r'\.', class_dict[classe][0])[0]
-                        #class_dict[classe].append(__import__(class_dict[classe][0]))
                         class_dict[classe].append(__import__(modulename))
                     except ModuleNotFoundError:
@@ -334,6 +341,9 @@
                 if class_dict[classe][0] not in ['dict', 'list', 'cell']:
                     modulename = split(r'\.', class_dict[classe][0])[0]
-                    class_dict[classe].append(__import__(modulename))
-                    class_tree[classe] = [group, ]
+                    if modulename == "giaivins":
+                        print("WARNING: module {} does not exist anymore and is skipped".format(modulename))
+                    else:
+                        class_dict[classe].append(__import__(modulename))
+                        class_tree[classe] = [group, ]
             except AttributeError:
                 print(('group {} is empty'.format(group)))
Index: issm/trunk/src/m/materials/cuffey.py
===================================================================
--- issm/trunk/src/m/materials/cuffey.py	(revision 25994)
+++ issm/trunk/src/m/materials/cuffey.py	(revision 26744)
@@ -3,17 +3,17 @@
 
 def cuffey(temperature):
-    """
-    CUFFEY - calculates ice rigidity as a function of temperature
+    """CUFFEY - calculates ice rigidity as a function of temperature
 
-       rigidity (in s^(1 / 3)Pa) is the flow law parameter in the flow law sigma = B * e(1 / 3)
-        (Cuffey and Paterson, p75).
-       temperature is in Kelvin degrees
+    rigidity (in s^(1/3)Pa) is the flow law parameter in the flow law 
+    sigma = B * e(1/3) (Cuffey and Paterson, p75).
 
-       Usage:
-          rigidity = cuffey(temperature)
+    temperature is in Kelvin degrees
+
+    Usage:
+        rigidity = cuffey(temperature)
     """
 
-    if np.any(temperature < 0.):
-        raise RuntimeError("input temperature should be in Kelvin (positive)")
+    if np.any(temperature < 0.0):
+        raise RuntimeError('input temperature should be in Kelvin (positive)')
 
     if np.ndim(temperature) == 2:
@@ -28,39 +28,39 @@
     pos = np.nonzero(T <= -45)
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000396645116301 * (T[pos] + 50)**3 + 0.013345579471334 * (T[pos] + 50)**2 - 0.356868703259105 * (T[pos] + 50) + 7.272363035371383)
+        rigidity[pos] = pow(10, 8) * (-0.000396645116301 * (T[pos] + 50)**3 + 0.013345579471334 * (T[pos] + 50)**2 - 0.356868703259105 * (T[pos] + 50) + 7.272363035371383)
     pos = np.nonzero(np.logical_and(-45 <= T, T < -40))
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000396645116301 * (T[pos] + 45)**3 + 0.007395902726819 * (T[pos] + 45)**2 - 0.253161292268336 * (T[pos] + 45) + 5.772078366321591)
+        rigidity[pos] = pow(10, 8) * (-0.000396645116301 * (T[pos] + 45)**3 + 0.007395902726819 * (T[pos] + 45)**2 - 0.253161292268336 * (T[pos] + 45) + 5.772078366321591)
     pos = np.nonzero(np.logical_and(-40 <= T, T < -35))
     if len(pos):
-        rigidity[pos] = 10**8 * (0.000408322072669 * (T[pos] + 40)**3 + 0.001446225982305 * (T[pos] + 40)**2 - 0.208950648722716 * (T[pos] + 40) + 4.641588833612773)
+        rigidity[pos] = pow(10, 8) * (0.000408322072669 * (T[pos] + 40)**3 + 0.001446225982305 * (T[pos] + 40)**2 - 0.208950648722716 * (T[pos] + 40) + 4.641588833612773)
     pos = np.nonzero(np.logical_and(-35 <= T, T < -30))
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000423888728124 * (T[pos] + 35)**3 + 0.007571057072334 * (T[pos] + 35)**2 - 0.163864233449525 * (T[pos] + 35) + 3.684031498640382)
+        rigidity[pos] = pow(10, 8) * (-0.000423888728124 * (T[pos] + 35)**3 + 0.007571057072334 * (T[pos] + 35)**2 - 0.163864233449525 * (T[pos] + 35) + 3.684031498640382)
     pos = np.nonzero(np.logical_and(-30 <= T, T < -25))
     if len(pos):
-        rigidity[pos] = 10**8 * (0.000147154327025 * (T[pos] + 30)**3 + 0.001212726150476 * (T[pos] + 30)**2 - 0.119945317335478 * (T[pos] + 30) + 3.001000667185614)
+        rigidity[pos] = pow(10, 8) * (0.000147154327025 * (T[pos] + 30)**3 + 0.001212726150476 * (T[pos] + 30)**2 - 0.119945317335478 * (T[pos] + 30) + 3.001000667185614)
     pos = np.nonzero(np.logical_and(-25 <= T, T < -20))
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000193435838672 * (T[pos] + 25)**3 + 0.003420041055847 * (T[pos] + 25)**2 - 0.096781481303861 * (T[pos] + 25) + 2.449986525148220)
+        rigidity[pos] = pow(10, 8) * (-0.000193435838672 * (T[pos] + 25)**3 + 0.003420041055847 * (T[pos] + 25)**2 - 0.096781481303861 * (T[pos] + 25) + 2.449986525148220)
     pos = np.nonzero(np.logical_and(-20 <= T, T < -15))
     if len(pos):
-        rigidity[pos] = 10**8 * (0.000219771255067 * (T[pos] + 20)**3 + 0.000518503475772 * (T[pos] + 20)**2 - 0.077088758645767 * (T[pos] + 20) + 2.027400665191131)
+        rigidity[pos] = pow(10, 8) * (0.000219771255067 * (T[pos] + 20)**3 + 0.000518503475772 * (T[pos] + 20)**2 - 0.077088758645767 * (T[pos] + 20) + 2.027400665191131)
     pos = np.nonzero(np.logical_and(-15 <= T, T < -10))
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000653438900191 * (T[pos] + 15)**3 + 0.003815072301777 * (T[pos] + 15)**2 - 0.055420879758021 * (T[pos] + 15) + 1.682390865739973)
+        rigidity[pos] = pow(10, 8) * (-0.000653438900191 * (T[pos] + 15)**3 + 0.003815072301777 * (T[pos] + 15)**2 - 0.055420879758021 * (T[pos] + 15) + 1.682390865739973)
     pos = np.nonzero(np.logical_and(-10 <= T, T < -5))
     if len(pos):
-        rigidity[pos] = 10**8 * (0.000692439419762 * (T[pos] + 10)**3 - 0.005986511201093 * (T[pos] + 10)**2 - 0.066278074254598 * (T[pos] + 10) + 1.418983411970382)
+        rigidity[pos] = pow(10, 8) * (0.000692439419762 * (T[pos] + 10)**3 - 0.005986511201093 * (T[pos] + 10)**2 - 0.066278074254598 * (T[pos] + 10) + 1.418983411970382)
     pos = np.nonzero(np.logical_and(-5 <= T, T < -2))
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000132282004110 * (T[pos] + 5)**3 + 0.004400080095332 * (T[pos] + 5)**2 - 0.074210229783403 * (T[pos] + 5) + 1.024485188140279)
+        rigidity[pos] = pow(10, 8) * (-0.000132282004110 * (T[pos] + 5)**3 + 0.004400080095332 * (T[pos] + 5)**2 - 0.074210229783403 * (T[pos] + 5) + 1.024485188140279)
     pos = np.nonzero(-2 <= T)
     if len(pos):
-        rigidity[pos] = 10**8 * (-0.000132282004110 * (T[pos] + 2)**3 + 0.003209542058346 * (T[pos] + 2)**2 - 0.051381363322371 * (T[pos] + 2) + 0.837883605537096)
+        rigidity[pos] = pow(10, 8) * (-0.000132282004110 * (T[pos] + 2)**3 + 0.003209542058346 * (T[pos] + 2)**2 - 0.051381363322371 * (T[pos] + 2) + 0.837883605537096)
 
-    #Now make sure that rigidity is positive
+    # Now make sure that rigidity is positive
     pos = np.nonzero(rigidity < 0)
-    rigidity[pos] = 1**6
+    rigidity[pos] = pow(1, 6)
 
     return rigidity
